#include <ESP8266WiFi.h>

const char *ssid  = ".....";                  // Werte eintragen
const char *pw    = ".....";                  // Werte eintragen

WiFiServer server(80);
String header;
String status5 = "off";
String status4 = "off";
const int output5   = 5;
const int output4   = D2;

void setup() {
    Serial.begin(115200);
    pinMode(output4, OUTPUT);
    pinMode(output5, OUTPUT);
    digitalWrite(output4, LOW);
    digitalWrite(output5, LOW);

    WiFi.begin(ssid, pw);
    while (WiFi.status() != WL_CONNECTED) {
        delay(500);
        Serial.print(".");
    }
    Serial.println("");                     // über Konsole wird IP ausgegeben
    Serial.println("WiFi connected.");
    Serial.print("IP adress: ");
    Serial.println(WiFi.localIP());
    server.begin();
}

void loop() {
    WiFiClient client = server.available();
    if (client) {
        String currentLine = "";
        while (client.connected()) {
            if (client.available()) {
                char c = client.read();
                header += c;
                if  (c == '\n') {
                    //Serial.println(header);
                    if (currentLine.length() == 0) {
                        client.println("HTTP/1.1 200 OK");
                        client.println("Content-type: text/html");
                        client.println("Connection: close");
                        client.println();
                        if (header.indexOf("GET /5/on") >= 0) {
                            Serial.println("GPIO5 on");
                            status5 = "on";
                            digitalWrite(output5, HIGH);
                        } else if (header.indexOf("GET /5/off") >= 0) {
                            Serial.println("GPIO5 off");
                            status5 = "off";
                            digitalWrite(output5, LOW); 
                        } else if (header.indexOf("GET /4/on") >= 0) {
                            Serial.println("GPIO4 on");
                            status4 = "on";
                            digitalWrite(output4, HIGH);
                        } else if (header.indexOf("GET /4/off") >= 0) {
                            Serial.println("GPIO4 off");
                            status4 = "off";
                            digitalWrite(output4, LOW); 
                        }
                        client.println("<!DOCTYPE html><html>");
                        client.println("<head>");
                        client.println("<meta name=\"viewport\" content=\"width=device-width, initial-scale=1\">");
                        client.println("<style>html {font-family: Helvetica, Arial, sans-serif; display: inline-block; margin: 0 auto; text-align: center;} ");
                        client.println("button {background: red; border: none; color: white; padding: 16px 40px; text-decoration: none; font-size: 30px; margin: 2px; cursor: pointer;} ");
                        client.println(".off {background: green;}</style>");
                        client.println("</head><body>");
                        client.println("<h1>ESP8266 Web Server</h1>");
                        client.println("<p>GPIO5 - State " + status5 + "</p>");
                        if (status5=="off") {
                            client.println("<p><a href=\"/5/on\"><button>ON</button></a></p>");
                        } else {
                            client.println("<p><a href=\"/5/off\"><button class=\"off\">OFF</button></a></p>");
                        }
                        client.println("<p>GPIO4 - State " + status4 + "</p>");
                        if (status4=="off") {
                            client.println("<p><a href=\"/4/on\"><button>ON</button></a></p>");
                        } else {
                            client.println("<p><a href=\"/4/off\"><button class=\"off\">OFF</button></a></p>");
                        }
                        client.println("</body></html>");
                        client.println();
                        break;
                    } else {
                        currentLine = "";
                    }
                } else if (c != '\r') {
                    currentLine += c;
                }
            }
        }
        header = "";
        client.stop();
    }
}
